const Vue = require('vue')
const path = require('path')

var options
var getPages

if (process.SERVER_BUILD) {
  // Since we can't pass options to Nuxt plugins, we have to repeat
  // the configuration here  :(
  options = (function () {
    const opts = require('../nuxt.config.js')
    opts.srcDir = opts.srcDir || './'
    const config = require('@nuxtjs/content/module/config.js')

    const options = Object.assign({}, config.defaults, opts.content)
    options.srcPath = opts.srcDir
    options.contentPath = path.resolve(opts.srcDir, options.srcDir)
    // `config.dirs` can be an Array but for simplicity we only read it as a 2D Array
    if (!Array.isArray(options.dirs[0])) options.dirs = [options.dirs]
    return options
  })()

  const fs = require('fs')
  console.log(fs.readFileSync('~/content/projects/Ency.md', 'utf-8'))
  getPages = require('@nuxtjs/content/lib/content/getPages')
}

Vue.use(() => {
  Vue.mixin({
    methods: {
      // Because of Weback's dependency management, we can only
      // require with a static path and ext. So helper method only gives
      // easy acess to registered directory files for user to require them
      // https://webpack.js.org/guides/dependency-management/
      $content(section) {
        const pagesData = getPages(options, path.join("/" + section))
        return Object.keys(pagesData).map(key => {
          const page = pagesData[key]
          // TODO
          // console.log(require('../content' + path.join(page.section + '/', page.fileName) + '.md'))
          return path.join(page.section + '/', page.fileName)
        })
      }
    }
  })
})
